import {
  Body,
  Controller,
  Delete,
  Get,
  Patch,
  Path,
  Post,
  Query,
  Request,
  Route,
  Security,
  Tags,
} from "tsoa";
import HttpError from "../interfaces/http-error";
import HttpStatus from "../interfaces/http-status";
import HttpSuccess from "../interfaces/http-success";
import { AppDataSource } from "../database/data-source";
import { Profile } from "../entities/Profile";
import { CreateProfileEdit, EditProfileEdit, ProfileEdit } from "../entities/ProfileEdit";
import { RequestWithUser } from "../middlewares/user";
import { Brackets } from "typeorm";
import CallAPI from "../interfaces/call-api";

@Route("api/v1/org/profile/edit")
@Tags("ProfileEdit")
@Security("bearerAuth")
export class ProfileEditController extends Controller {
  private profileRepo = AppDataSource.getRepository(Profile);
  private profileEditRepo = AppDataSource.getRepository(ProfileEdit);

  @Get("user")
  public async detailProfileEditUser(
    @Request() request: { user: Record<string, any> },
    @Query("page") page: number = 1,
    @Query("pageSize") pageSize: number = 10,
    @Query("keyword") keyword: string = "",
    @Query("status") status: string = "",
  ) {
    const profile = await this.profileRepo.findOneBy({ keycloak: request.user.sub });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }

    let [getProfileEdit, total] = await AppDataSource.getRepository(ProfileEdit)
      .createQueryBuilder("ProfileEdit")
      .leftJoinAndSelect("ProfileEdit.profile", "profile")
      .where((qb) => {
        if (status != "" && status != null) {
          qb.andWhere("ProfileEdit.status = :status", { status: status });
        }
        qb.andWhere("ProfileEdit.profileId = :profileId", { profileId: profile.id });
      })
      .andWhere(
        new Brackets((qb) => {
          qb.where(keyword != "" && keyword != null ? "ProfileEdit.topic LIKE :keyword" : "1=1", {
            keyword: `%${keyword}%`,
          }).orWhere(
            keyword != "" && keyword != null ? "ProfileEdit.detail LIKE :keyword" : "1=1",
            {
              keyword: `%${keyword}%`,
            },
          );
        }),
      )
      .orderBy("ProfileEdit.createdAt", "DESC")
      .skip((page - 1) * pageSize)
      .take(pageSize)
      .getManyAndCount();

    const _data = getProfileEdit.map((item) => ({
      id: item.id,
      topic: item.topic,
      detail: item.detail,
      status: item.status,
      remark: item.remark,
      createdAt: item.createdAt,
      createdFullName: item.createdFullName,
      lastUpdatedAt: item.lastUpdatedAt,
      lastUpdateFullName: item.lastUpdateFullName,
      fullname:
        (item?.profile?.prefix ?? "") +
        "" +
        (item?.profile?.firstName ?? "") +
        " " +
        (item?.profile?.lastName ?? ""),
    }));
    return new HttpSuccess({ data: _data, total: total });
  }

  @Get("admin")
  public async detailProfileEditAdmin(
    @Request() request: { user: Record<string, any> },
    @Query("page") page: number = 1,
    @Query("pageSize") pageSize: number = 10,
    @Query("keyword") keyword: string = "",
    @Query("status") status: string = "",
  ) {
    let [getProfileEdit, total] = await AppDataSource.getRepository(ProfileEdit)
      .createQueryBuilder("ProfileEdit")
      .leftJoinAndSelect("ProfileEdit.profile", "profile")
      .where((qb) => {
        if (status != "" && status != null) {
          qb.andWhere("ProfileEdit.status = :status", { status: status });
        }
        qb.andWhere("ProfileEdit.profileId IS NOT NULL");
      })
      .andWhere(
        new Brackets((qb) => {
          qb.where(keyword != "" && keyword != null ? "ProfileEdit.topic LIKE :keyword" : "1=1", {
            keyword: `%${keyword}%`,
          }).orWhere(
            keyword != "" && keyword != null ? "ProfileEdit.detail LIKE :keyword" : "1=1",
            {
              keyword: `%${keyword}%`,
            },
          );
        }),
      )
      .orderBy("ProfileEdit.createdAt", "DESC")
      .skip((page - 1) * pageSize)
      .take(pageSize)
      .getManyAndCount();
    const _data = getProfileEdit.map((item) => ({
      id: item.id,
      idcard: item.profile.citizenId,
      profileId: item.profile.id,
      topic: item.topic,
      detail: item.detail,
      status: item.status,
      remark: item.remark,
      createdAt: item.createdAt,
      createdFullName: item.createdFullName,
      lastUpdatedAt: item.lastUpdatedAt,
      lastUpdateFullName: item.lastUpdateFullName,
      fullname:
        (item?.profile?.prefix ?? "") +
        "" +
        (item?.profile?.firstName ?? "") +
        " " +
        (item?.profile?.lastName ?? ""),
    }));
    return new HttpSuccess({ data: _data, total: total });
  }

  //   @Get("{Id}")
  //   public async detailProfileByIdEdit(@Path() Id: string) {
  //     const getProfileEdit = await this.profileEditRepo.findOne({
  //       where: { id: Id },
  //     });
  //     if (!getProfileEdit) {
  //       throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
  //     }
  //     return new HttpSuccess(getProfileEdit);
  //   }

  @Get("{id}")
  public async detailProfileEdit(@Path() id: string) {
    const getProfileEdit = await this.profileEditRepo.findOne({
      where: { id: id },
      relations: ["profile"],
    });
    if (!getProfileEdit) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }
    const _data = {
      id: getProfileEdit.id,
      topic: getProfileEdit.topic,
      detail: getProfileEdit.detail,
      citizenId: getProfileEdit?.profile?.citizenId ?? "",
      status: getProfileEdit.status,
      remark: getProfileEdit.remark,
      createdAt: getProfileEdit.createdAt,
      createdFullName: getProfileEdit.createdFullName,
      lastUpdatedAt: getProfileEdit.lastUpdatedAt,
      lastUpdateFullName: getProfileEdit.lastUpdateFullName,
      fullname:
        (getProfileEdit?.profile?.prefix ?? "") +
        "" +
        (getProfileEdit?.profile?.firstName ?? "") +
        " " +
        (getProfileEdit?.profile?.lastName ?? ""),
    };
    return new HttpSuccess(_data);
  }

  @Post()
  public async newProfileEdit(@Request() req: RequestWithUser, @Body() body: CreateProfileEdit) {
    const profile = await this.profileRepo.findOne({
      where: { keycloak: req.user.sub },
      relations: ["posLevel", "posType"],
    });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }

    const data = new ProfileEdit();
    const meta = {
      createdUserId: req.user.sub,
      createdFullName: req.user.name,
      lastUpdateUserId: req.user.sub,
      lastUpdateFullName: req.user.name,
      createdAt: new Date(),
      lastUpdatedAt: new Date(),
    };

    Object.assign(data, { ...body, ...meta });
    data.status = "PENDING";
    await this.profileEditRepo.save(data);

    await new CallAPI()
      .PostData(req, "/org/workflow/add-workflow", {
        refId: data.id,
        sysName: "REGISTRY_PROFILE",
        posLevelName: profile.posLevel.posLevelName,
        posTypeName: profile.posType.posTypeName,
      })
      .catch((error) => {
        console.error("Error calling API:", error);
      });

    return new HttpSuccess(data.id);
  }

  @Patch("{editId}")
  public async editProfileEdit(
    @Body() requestBody: EditProfileEdit,
    @Request() req: RequestWithUser,
    @Path() editId: string,
  ) {
    // const record = await this.profileEditRepo.findOneBy({ id: editId });
    const record = await this.profileEditRepo.findOne({
      where: { id: editId },
    });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");

    Object.assign(record, requestBody);

    record.lastUpdateFullName = req.user.name;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdatedAt = new Date();
    await Promise.all([this.profileEditRepo.save(record)]);

    return new HttpSuccess();
  }

  @Delete("{editId}")
  public async deleteProfileEdit(@Path() editId: string) {
    const result = await this.profileEditRepo.delete({ id: editId });

    if (result.affected == undefined || result.affected <= 0)
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");

    return new HttpSuccess();
  }
}
